/* $Id: krug-ko.pl,v 1.1 1995/12/01 20:01:54 uwe Exp $ */
/*  Kostenfuntionen und Heuristiken fuer Wasserkrug */

:- assert((help :-
	write('Kostenfunktionen und Heuristiken fuer das Wasserkrugproblem'), nl,
	write('  breitensuche.	-> g(n) =  1, g(n) = 0'), nl,
	write('  tiefensuche.	-> g(n) = -1, h(n) = 0'), nl,
        write('  bestensuche.	-> g(n) =  0, h(n) = Abstand zu 2l im 4-er Krug'), nl,
	write('  wasserkosten.	-> g(n) =  wassermenge, h(n) = 0'), nl,
	write('  bestensuche1.	-> g(n) =  wassermenge, h(n) = 3 * Abstand zu 2l im 4-er Krug'), nl,
	write('Voreinstellung: breitensuche'), nl,
	nl, fail)
	).

bestensuche :-
	kostenkonstant(0),
        setrule(guess(_,_),
                (guess((W : _) :-> _, C) :-
			abstand(W,2,C))
        ).

bestensuche1 :-
	setrule(pathcost(_,_,_),
		(pathcost(O :-> _, N :->  _, C) :-
			wasser(O, N, C)
		)
	),
        setrule(guess(_,_),
		(guess((W : _) :-> _, C) :-
			abstand(W,2,C1),
			C is C1 * 3
		)
        ).

wasserkosten :-
	setrule(pathcost(_,_,_),
		(pathcost(O :-> _, N :->  _, C) :-
			wasser(O, N, C)
		)
	),
	keineheuristik.

/*-------------------------------------------------------------------------------------*/

abstand(I, J, K) :-
	I < J,
	!,
	K is J - I.
abstand(I, J, K) :-
	K is I - J.

wasser(O4 : O3, N4 : N3, W) :-
	O is O4 + O3,
	N is N4 + N3,
	O < N,
	!,
	W is N - O.

wasser(_, _, 0).

/*-------------------------------------------------------------------------------------*/

