/* $Id: krug-re.pl,v 1.1 1995/12/01 20:01:55 uwe Exp $ */

/* Wasserkrugproblem
   Knoten sind Paare X:Y wobei X Werte zwischen 0 und 4
   und Y Werte Zwischen 0 und 3 annehmen kann.

*/

:-op(200,xfx,:).

rule('4-er Krug voll fuellen', X:Y, 4:Y) :- 
	X < 4.

rule('3-er Krug voll fuellen', X:Y, X:3) :- 
	Y < 3.

rule('4-er Krug leeren'      , X:Y, 0:Y) :- 
	X > 0.

rule('3-er Krug leeren'      , X:Y, X:0) :- 
	Y > 0.

rule('4-er Krug aus 3-er Krug fuellen', X:Y, 4:Z) :- 
	X < 4, X + Y >= 4, 
	Z is X + Y - 4.

rule('3-er Krug aus 4-er Krug fuellen', X:Y, Z:3) :- 
	Y < 3, X + Y >= 3, 
	Z is X + Y - 3.

rule('3-er Krug in 4-er Krug leeren', X:Y, Z:0) :-
	Y > 0, X + Y < 4, 
	Z is X + Y.

rule('4-er Krug in 3-er Krug leeren', X:Y, 0:Z) :-
	X > 0, X + Y < 3, 
	Z is X + Y.

/*--- Loesung -------------------------------------------------------------------------*/

solution(2:_).

/*--- Ausgabe -------------------------------------------------------------------------*/

outstate(S) :- 
	writes(S).
outrule(R) :-
	write(' --> ('),
	write(R),
	write(')'),
	nl.

writes(X:Y) :-
	write(X),
	write(':'),
	write(Y).

writes(X+Y) :-
	write(X),
	write('+'),
	write(Y).

/*-------------------------------------------------------------------------------------*/
