/* mug5.P,v 1.2 1993/11/24 18:43:34 uwe Exp */
/* Breitensuche in einem Graph           */
/* append wird durch union ersetzt       */
/* ohne Erklaerungskomponente            */
/* Zyklen werden nicht erkannt           */

:-op(200,xfx,:).

writes(X:Y) :-
	write(X),
	write(':'),
	write(Y).

writel(L) :-
	write('['),
	writer(L),
	write(']').

writer([]).

writer([H]) :-
	writes(H),
	!.

writer([H|T]) :-
	writes(H),
	write(','),
	writer(T).

rule(X:Y, 4:Y) :- 
	X < 4.
rule(X:Y, X:3) :- 
	Y < 3.
rule(X:Y, 0:Y) :- 
	X > 0.
rule(X:Y, X:0) :- 
	Y > 0.
rule(X:Y, 4:Z) :- 
	X < 4, X + Y >= 4, 
	Z is X + Y - 4.
rule(X:Y, Z:3) :- 
	Y < 3, X + Y >= 3, 
	Z is X + Y - 3.
rule(X:Y, Z:0) :-
	Y > 0, X + Y < 4, 
	Z is X + Y.
rule(X:Y, 0:Z) :-
	X > 0, X + Y < 3, 
	Z is X + Y.
    
/* generiere alle Nachfolger aus einem Knoten */

gen1(S,L) :-
	findall(S1,rule(S,S1),L).

/* generiere alle Nachfolger aus einer Liste */
gen([],[]).
gen([S|T],Succ) :- 
	gen1(S,Succ1), 
	gen(T,  Succ2), 
	union(Succ1,Succ2,Succ,S).
  
union([],S,S,_).
union([H|T],S2,S,OLD) :- 
        writes(H),
        writes(OLD),
	isin(H,S2),
	!,
	union(T,S2,S,OLD).
union([H|T],S2,[H|S],OLD) :- 
	union(T,S2,S,OLD).
 
isin(S,[H|_]) :- 
	S = H,
	!.
isin(S,[_|T]) :- 
	isin(S,T).

solve(Statelist,G,_,_) :- 
	isin(G,Statelist), 
	!.

solve(_,_,Max,Max) :- 
	!, fail.
  
solve(Statelist,G,N,Max) :- 
	gen(Statelist,Succ), 
	N1 is N + 1, 
	nl,writel(Succ),nl, 
	solve(Succ,G,N1,Max).

zweiliter(Max) :- 
	solve([0:0], 2:_, 0, Max), !.
         
