/* mug6.P,v 1.2 1993/11/24 18:43:34 uwe Exp */
/* Breitensuche in einem Graph           */
/* schon besuchte Knoten werden nicht    */
/* wieder beruecksichtigt                */
/* solve erhaelt die Menge der schon     */
/* besuchten Knoten als zusaetzlichen    */
/* Parameter                             */
/* ohne Erklaerungskomponente            */

:-op(200,xfx,:).

writes(X:Y) :-
	write(X),
	write(':'),
	write(Y).

writel(L) :-
	write('['),
	writer(L),
	write(']').

writer([]).

writer([H]) :-
	writes(H),
	!.

writer([H|T]) :-
	writes(H),
	write(','),
	writer(T).

rule(X:Y, 4:Y) :- 
	X < 4.
rule(X:Y, X:3) :- 
	Y < 3.
rule(X:Y, 0:Y) :- 
	X > 0.
rule(X:Y, X:0) :- 
	Y > 0.
rule(X:Y, 4:Z) :- 
	X < 4, X + Y >= 4, 
	Z is X + Y - 4.
rule(X:Y, Z:3) :- 
	Y < 3, X + Y >= 3, 
	Z is X + Y - 3.
rule(X:Y, Z:0) :-
	Y > 0, X + Y < 4, 
	Z is X + Y.
rule(X:Y, 0:Z) :-
	X > 0, X + Y < 3, 
	Z is X + Y.
    
/* generiere alle Nachfolger aus einem Knoten */
  
gen1(S,L) :-
	findall(S1,rule(S,S1),L).

/* generiere alle Nachfolger aus einer Liste */
gen([],[]).
gen([S|T],Succ) :- 
	gen1(S,Succ1), 
	gen(T,  Succ2), 
	union1(Succ1,Succ2,Succ,S).
  
/* union1(S1,S2,S1 u S2) */
union1([],S,S,_).
union1([H|T],S2,S,OLD) :- 
        writes(H),
        writes(OLD),
	isin(H,S2),
	!,
	union1(T,S2,S,OLD).
union1([H|T],S2,[H|S],OLD) :- 
	union1(T,S2,S,OLD).
union1([],S,S).
union1([H|T],S2,S) :- 
	isin(H,S2),
	!,
	union1(T,S2,S).
union1([H|T],S2,[H|S]) :- 
	union1(T,S2,S).
 
/* minus(S1,S2,S1 - S2) */
minus(S1,[],S1).
minus(S1,[H|S2],S3) :- 
	minus1(H,S1,S4),
	minus(S4,S2,S3).
minus1(_,[],[]).
minus1(E,[H|T],   S ) :- 
	E=H, 
	!, 
	minus1(E,T,S).
minus1(E,[H|T],[H|S]) :-         
	minus1(E,T,S). 

isin(S,[H|_]) :- 
	S = H,
	!.
isin(S,[_|T]) :- 
	isin(S,T).

solve(Statelist,G,_,_,_) :- 
	isin(G,Statelist), 
	!.

solve(_,_,Max,Max,_) :- 
	!, fail.
  
solve(Statelist,G,N,Max,Visited) :- 
	gen(Statelist,Succ), 
	union1(Visited,Statelist,Newvisited), 
	minus(Succ,Newvisited,Newsucc), 
	N1 is N + 1, 
	nl,writel(Newsucc),nl, 
	solve(Newsucc,G,N1,Max,Newvisited).

zweiliter(Max) :- 
	solve([0:0], 2:_, 0, Max, []), 
	!.
